
-- Bresenham's line algorithm
Mtx=0
Mty=0
MapPointList={}

function AddPoint(x,y)
	t={}
	t.x=x
	t.y=y
	t.ex=x
	t.ey=y
	for k,v in ipairs(MapPointList) do
	t.ex=v.x
	t.ey=v.y
	end
	table.insert(MapPointList,t)
end




function Line(x0,y0,x1,y1)
   local dx = math.abs(x1-x0)
   local dy = math.abs(y1-y0)
   local sx,sy
   if x0 < x1 then sx=1 else sx=-1 end
   if y0 < y1 then sy=1 else sy=-1 end
   local err = dx-dy
    local loop=true
	while loop==true do 
	love.graphics.point( x0, y0 )
	if x0==x1 and y0==y1 then
	loop=false
	end
	local e2 = 2*err
    if e2 > -dy then
       err = err-dy
       x0  = x0+sx
    end
    if e2 < dx then
       err = err+dx
       y0  = y0+sy
    end
	end
end

function CubeLine(x0,y0,x1,y1)
   local dx = math.abs(x1-x0)
   local dy = math.abs(y1-y0)
   local sx,sy
   if x0 < x1 then sx=1 else sx=-1 end
   if y0 < y1 then sy=1 else sy=-1 end
   local err = dx-dy
    local loop=true
	while loop==true do 
	love.graphics.rectangle("line",x0*10, y0*10,10,10 )
	if x0==x1 and y0==y1 then
	loop=false
	end
	local e2 = 2*err
    if e2 > -dy then
       err = err-dy
       x0  = x0+sx
    end
    if e2 < dx then
       err = err+dx
       y0  = y0+sy
    end
	end
end


function love.load()
love.graphics.setMode(800,600)
love.graphics.setPoint(1, "smooth")
love.graphics.setLine( 1, "smooth" )
end

function love.mousepressed(x, y, button)
   if button == "l" then
	AddPoint(Mtx,Mty)
   end
   if button == "r" then
   --for k,v in ipairs(MapPointList) do
   table.remove(MapPointList)
   --end
   end
end

function love.update(dt)
Mtx=math.floor(love.mouse.getX()/10)
Mty=math.floor(love.mouse.getY()/10)
--My=math.floor(love.mouse.getY()/10)
end

function love.draw()
	love.graphics.print("Left Mouse Click for place a point , Right Click for undo last point :",0,0)
	-- Mountain:
	for k,v in ipairs(MapPointList) do
	CubeLine(v.x,v.y,v.ex,v.ey)
	Line(v.x*10+5,v.y*10+5,v.ex*10+5,v.ey*10+5)
	end
	
end





